package com.fs.his.strategy;

import com.fs.his.domain.FsUserRewards;

/**
 * App用户奖品策略接口
 */
public interface RewardStrategy {
    /**
     * 处理奖品发放
     * @param reward 奖品信息
     * @return 发放结果
     */
    RewardResult process(FsUserRewards reward);

    /**
     * 获取支持的活动类型
     */
    String getActivityType();

    /**
     * 获取支持的奖品类型
     */
    Integer getRewardType();

    /**
     * 是否支持该奖品发送条件
     */
    default boolean support(String activityType, Integer rewardType) {
        return getActivityType().equals(activityType) && getRewardType().equals(rewardType);
    }
}